#----------------------------------------------------------------------#
#  ޴ ȸ  Լ... *^^*
#----------------------------------------------------------------------#
require "./cgi_lib/load_msg.cgi";
require "./cgi_lib/head_foot.cgi";
require "./cgi_lib/read_cookie.cgi";

sub mem_conf {
	&read_cookie; 
	require "./cgi_lib/chk_admin.cgi";
	&chk_admin;

	local %ADMIN = &load_msg("$CONF{'lang'}", "admin");
	local ($cnt_grp, @mem_grp);

	open(GRP, "$main_dir/member/grp_idx.cgi");
	chomp(@mem_grp = <GRP>);
	close(GRP);
	$cnt_grp = @mem_grp;

	$mode = $FORM{'mode'};
	
	if($mode eq "") {
		&conf_form;
	}
	elsif($mode eq "write_conf") {
		&write_conf;
	}
}

sub write_conf {
	my $file_name = "mem_conf.cgi"; 
	$file_name = "default_".$file_name unless($FORM{'id'});
	
	for(@mem_grp) {
		my($grp_id, $grp_title);
		if($_ =~ /([^=]*?)\s*=\s*(.*?)\s*$/) {
			$grp_id = $1;
			$grp_title = $2;
		}

		my $key_view = "reject_view_$grp_id";
		$reject_view_val .= "$grp_id:" if($FORM{$key_view}); 

		my $key_down = "reject_down_$grp_id";
		$reject_down_val .= "$grp_id:" if($FORM{$key_down}); 

		my $key_write = "reject_write_$grp_id";
		$reject_write_val .= "$grp_id:" if($FORM{$key_write}); 
		
		my $key_reply = "reject_reply_$grp_id";
		$reject_reply_val .= "$grp_id:" if($FORM{$key_reply}); 

		my $key_etc = "reject_etc_$grp_id";
		$reject_etc_val .= "$grp_id:" if($FORM{$key_etc}); 

		my $key_all = "reject_all_$grp_id";
		$reject_all_val .= "$grp_id:" if($FORM{$key_all}); 
	}
	$reject_view_val .= "no_mem" if($FORM{'reject_view_no_mem'}); 
	$reject_down_val .= "no_mem" if($FORM{'reject_down_no_mem'}); 
	$reject_write_val .= "no_mem" if($FORM{'reject_write_no_mem'}); 
	$reject_reply_val .= "no_mem" if($FORM{'reject_reply_no_mem'});
	$reject_etc_val .= "no_mem" if($FORM{'reject_etc_no_mem'}); 	
	$reject_all_val .= "no_mem" if($FORM{'reject_all_no_mem'});
	
	open(MEM, ">$data_dir/$file_name");
	print MEM "real_name = $FORM{'real_name'}\n";	
	print MEM "no_name_icon = $FORM{'no_name_icon'}\n";
	print MEM "use_photo = $FORM{'use_photo'}\n";
	print MEM "photo_view = $FORM{'photo_view'}\n";
	print MEM "photo_etc = $FORM{'photo_etc'}\n";
	print MEM "reject_down = $reject_down_val\n";
	print MEM "reject_view = $reject_view_val\n";
	print MEM "reject_write = $reject_write_val\n";
	print MEM "reject_reply = $reject_reply_val\n";
	print MEM "reject_etc = $reject_etc_val\n";
	print MEM "reject_all = $reject_all_val\n";
	close(MEM);

	# Ʈ ϱ
	my $point_fname = "point.cgi"; 
	$point_fname = "default_".$point_fname unless($FORM{'id'});
	
	$POINT{'view'}  = $FORM{'point_view'};
	$POINT{'vote'}  = $FORM{'point_vote'};
	$POINT{'write'} = $FORM{'point_write'};
	$POINT{'reply'} = $FORM{'point_reply'};
	$POINT{'etc'}   = $FORM{'point_etc'};
	$POINT{'limit'} = $FORM{'point_limit'};
	
	open(POINT, ">$data_dir/$point_fname");
	foreach $key(keys %POINT) {
		print POINT "$key = $POINT{$key}\n";
	}
	close(POINT);

	require "./cgi_lib/load_page.cgi";
	my $tmp_id = $FORM{'id'};
	$FORM{'id'} = ""; # Ʒ HTMLױ  ʰ ϱ .
	&load_page("$cgi_url?id=$tmp_id&action=mem_conf", "1", "chg_mem_conf");
}

sub conf_form {
	my($chk_real_name, $chk_no_name_icon, $chk_use_photo, $chk_photo_view, $chk_photo_etc,$grp_tbl);

	unless($FORM{'id'}) {
		open(MEM, "$data_dir/default_mem_conf.cgi");
		foreach (<MEM>){
			if (/([^=]*?)\s*=\s*(.*?)\s*$/) {
				if(($1 eq "real_name") || ($1 eq "no_name_icon") || ($1 eq "use_photo") || ($1 eq "photo_view") || ($1 eq "photo_etc")) {
					$CONF{$1} = $2;
					next;
				}
				$hash_name = $1;
				my @tmp_arr = @{$has_name} = split(/:/, $2);
				
				foreach (@tmp_arr) {
					$_ =~ s/ //g;
					last if($_ eq "");
					${$hash_name}{$_} = "on";
				}
			}
		}
		close(MEM);	
	}
	$chk_real_name = $CONF{'real_name'} ? "checked" : "";
	$chk_no_name_icon = $CONF{'no_name_icon'} ? "checked" : "";
	$chk_use_photo = $CONF{'use_photo'} ? "checked" : "";
	$chk_photo_view = $CONF{'photo_view'} ? "checked" : "";
	$chk_photo_etc = $CONF{'photo_etc'} ? "checked" : "";

	$grp_tbl = "<table width=100% border=1 cellpadding=3 cellspacing=0 bordercolordark=\"$CONF{'head_color'}\" bordercolorlight=\"$CONF{'hfont_color'}\">\n";
	$grp_tbl .= "<tr bgcolor=\"$CONF{'select_color'}\"><td nowrap align=center>$ADMIN{'mem_grp'}</td><td nowrap align=center>$ADMIN{'reject_view'}</td><td nowrap align=center>$ADMIN{'reject_down'}</td>";
	$grp_tbl .= "<td nowrap align=center>$ADMIN{'reject_write'}</td><td nowrap align=center>$ADMIN{'reject_reply'}</td><td nowrap align=center>$ADMIN{'reject_etc'}</td><td nowrap align=center>$ADMIN{'reject_all'}</td></tr>\n";
	my($chk_reject_down, $chk_reject_view, $chk_reject_write, $chk_reject_all);
	for (@mem_grp) {
		my($grp_id, $grp_title);
		if($_ =~ /([^=]*?)\s*=\s*(.*?)\s*$/) {
			$grp_id = $1;
			$grp_title = $2;
		}

		$chk_reject_view = ($reject_view{$grp_id}) ? "checked" : "";
		$chk_reject_down = ($reject_down{$grp_id}) ? "checked" : "";
		$chk_reject_write = ($reject_write{$grp_id}) ? "checked" : "";
		$chk_reject_reply = ($reject_reply{$grp_id}) ? "checked" : "";
		$chk_reject_etc = ($reject_etc{$grp_id}) ? "checked" : "";
		$chk_reject_all = ($reject_all{$grp_id}) ? "checked" : "";

		$grp_tbl .= "<tr><td nowrap align=center>$grp_title</td>";
		$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_view_$grp_id $chk_reject_view></td>";
		$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_down_$grp_id $chk_reject_down></td>";
		$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_write_$grp_id $chk_reject_write></td>";
		$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_reply_$grp_id $chk_reject_reply></td>";
		$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_etc_$grp_id $chk_reject_etc></td>";
		$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_all_$grp_id $chk_reject_all></td></tr>\n";
	}
	$chk_reject_view = ($reject_view{'no_mem'}) ? "checked" : "";
	$chk_reject_down = ($reject_down{'no_mem'}) ? "checked" : "";
	$chk_reject_write = ($reject_write{'no_mem'}) ? "checked" : "";
	$chk_reject_reply = ($reject_reply{'no_mem'}) ? "checked" : "";
	$chk_reject_etc = ($reject_etc{'no_mem'}) ? "checked" : "";
	$chk_reject_all = ($reject_all{'no_mem'}) ? "checked" : "";

	$grp_tbl .= "<tr><td nowrap align=center>$ADMIN{'no_mem'}</td>";
	$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_view_no_mem $chk_reject_view></td>";
	$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_down_no_mem $chk_reject_down></td>";
	$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_write_no_mem $chk_reject_write></td>";
	$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_reply_no_mem $chk_reject_reply></td>";
	$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_etc_no_mem $chk_reject_etc></td>";
	$grp_tbl .= "<td nowrap align=center><input type=checkbox name=reject_all_no_mem $chk_reject_all></td></tr>\n";
	$grp_tbl .= "</table>";

	# Ʈ ҷ...  *^^*
	my $point_fname = "point.cgi"; 
	$point_fname = "default_".$point_fname unless($FORM{'id'});
	open(POINT, "$data_dir/$point_fname");
	foreach (<POINT>) { 
		if(/([^=]*?)\s*=\s*(.*?)\s*$/) {
			$POINT{$1} = $2;
		}
	}
	close(POINT);

	$POINT{'view'} ||= 0;
	$POINT{'vote'} ||= 0;
	$POINT{'write'} ||= 0;
	$POINT{'reply'} ||= 0;
	$POINT{'etc'} ||= 0;
	$POINT{'limit'} ||= 0;

	my $point_list = qq!
			<br>
			<img src=$img_skin/sub.gif> $ADMIN{'msg_point'}<br>
			<img src=$img_skin/zero.gif width=100% height=4><br>
			<table width=100% border=1 cellpadding=3 cellspacing=0 bordercolordark="$CONF{'head_color'}" bordercolorlight="$CONF{'hfont_color'}">
			<tr>
				<td align=center bgcolor="$CONF{'select_color'}">$ADMIN{'point_sub'}</td>
				<td align=center>$ADMIN{'point_view'}</td>
				<td align=center>$ADMIN{'point_vote'}</td>
				<td align=center>$ADMIN{'point_write'}</td>
				<td align=center>$ADMIN{'point_reply'}</td>
				<td align=center>$ADMIN{'point_etc'}</td>
			</tr>
			<tr>
				<td align=center bgcolor="$CONF{'select_color'}">$ADMIN{'point_num'}</td>
				<td align=center><input type=text name=point_view size=3 value="$POINT{'view'}" class=input></td>
				<td align=center><input type=text name=point_vote size=3 value="$POINT{'vote'}" class=input></td>
				<td align=center><input type=text name=point_write size=3 value="$POINT{'write'}" class=input></td>
				<td align=center><input type=text name=point_reply size=3 value="$POINT{'reply'}" class=input></td>
				<td align=center><input type=text name=point_etc size=3 value="$POINT{'etc'}" class=input></td>
			</tr>
		</table>
		<table width=100% border=0 cellpadding=3 cellspacing=0>
		<tr><td align=right>$ADMIN{'point_limit'} <input type=text name=point_limit size=3 value="$POINT{'limit'}" class=input></td></tr>
		</table>
	!;
	
	&head("$ADMIN{'mem_conf'}");
	print <<"    __MEM_CONF__";
		<script language="javascript">
			self.resizeTo(630, 585);
			self.window.focus();

			function chk_point() {
				var point_limit = document.form.point_limit.value;
				if(document.form.reject_write_no_mem.checked == true || document.form.reject_all_no_mem.checked == true) {
					var no_mem_write = true; 
				}
				var chk_msg = "$ADMIN{'confirm_chk_point'}";
				if(no_mem_write != true && point_limit > 0) {
					if(confirm(chk_msg)){
						document.form.reject_write_no_mem.checked = true;
						return true;
					}
					return true;
				}
			}
		</script>
		<form name=form method=post action=$cgi_url onSubmit="chk_point();">
		<input type=hidden name=id value=$FORM{'id'}>
		<input type=hidden name=action value="mem_conf">
		<input type=hidden name=mode value="write_conf">

		<table border=0 cellpadding=0 cellspacing=0 bordercolordark="$CONF{'hfont_color'}" bordercolorlight="$CONF{'head_color'}" align=center width=100%>
			<tr>
				<td align=right><img src=$img_url/head_img/$CONF{'head_img'}/hd_left.gif></td>
				<td align=center background=$img_url/head_img/$CONF{'head_img'}/hd_bg.gif>&nbsp;</td>
				<td align=left><img src=$img_url/head_img/$CONF{'head_img'}/hd_right.gif></td>
			</tr>
			<tr>
				<td></td>
				<td bgcolor="$CONF{'tr_color01'}">
						<table border=0 width=100% cellspacing=0 cellpadding=3>
							<tr>
								<td align=right>$ADMIN{'real_name'} <input type=checkbox name=real_name $chk_real_name></td>
							</tr>
							<tr>
								<td align=right>$ADMIN{'no_name_icon'} <input type=checkbox name=no_name_icon $chk_no_name_icon></td>
							</tr>
							<tr>
								<td align=right>
									$ADMIN{'use_photo'} <input type=checkbox name=use_photo $chk_use_photo> -
									$ADMIN{'photo_view'} <input type=checkbox name=photo_view $chk_photo_view>
									$ADMIN{'photo_etc'} <input type=checkbox name=photo_etc $chk_photo_etc>
								</td>
							</tr>
							<tr>
								<td>
									$grp_tbl
								</td>
							</tr>
							<tr>
								<td>
									$point_list	
								</td>
							</tr>
						</table>
						<img src=$img_skin/zero.gif width=100% height=4><br>
				</td>
				<td></td>
			</tr>
			<tr>
				<td></td>
				<td align=right style="padding:3"><input type=image src=$img_skin/submit.gif border=0 value="$ADMIN{'submit'}"><a href=javascript:parent.close()><img src=$img_skin/send_close.gif border=0 alt="$ADMIN{'close_win'}"></a></td>
				<td></td>
		</tr>
		</table>
		</form>
    __MEM_CONF__
	
	&foot;
}

return 1;