#---------------------------------------------------------------------#
# ¥   µ ϵ ϴ Լ.. *^^*
#---------------------------------------------------------------------#

sub conv_date {
	my $date_val;
	my ($year_val, $mon_val, $day_val, $hour_val, $min_val, $week_val) = @_;

	if($week_val) {
		require "./cgi_lib/get_week.cgi";
		$week_val = &get_week($week_val);
	}
	
	if($CONF{'eng_mon'}) {
		my @eng_mon = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
		$mon_val = $eng_mon[$mon_val -1];
	}
	
	$CONF{'date_order'} ||= "<!--YEAR-->.<!--MON-->.<!--DAY-->";
	
	$date_val = $CONF{'date_order'};

	$date_val =~ s/<!--YEAR-->/$year_val/eo;
	$date_val =~ s/<!--MON-->/$mon_val/eo;
	$date_val =~ s/<!--DAY-->/$day_val/eo;

	$date_val .= " $week_val" if($week_val); 
	$date_val .= " - $hour_val:$min_val" if($hour_val || $min_val);
	return $date_val;
}

return 1;