#----------------------------------------------------------------------#
#   ī Ÿ ϴ Լ.... *^^*
#----------------------------------------------------------------------#
require "./cgi_lib/lock.cgi";

sub chk_count {
	require "./cgi_lib/read_cookie.cgi";
	&read_cookie;
	my $cook_name = "CNT_$FORM{'id'}";
	if($COOKIE{$cook_name} eq "") {
		local $cnt_dir = "$data_dir/count";
		local ($today_year, $today_mon, $today_day);

		#  ¥  ð 
		local($hour, $day, $mon, $year, $week);
		(undef, undef, $hour, $day, $mon, $year, $week) = map {sprintf "%.2d", $_} localtime;
		$year += 1900;
		$mon++;

		# ¥ üŷ - ¥  ӽõŸ 迡 Ұ!
		if(-e "$cnt_dir/today_date.cgi") {
			open(TODAY, "$cnt_dir/today_date.cgi");
			($today_year, $today_mon, $today_day) = split(/\./, <TODAY>);
			close(TODAY);
		}
		else { #  ȣ!
			($today_year, $today_mon, $today_day) = ($year, $mon, $day);
			# ο ¥ Է
			&lock("today_date");
			open(TODAY, ">$cnt_dir/today_date.cgi");
			print TODAY "$year.$mon.$day";
			close(TODAY);
			&unlock("today_date");		
		}
		
		if($today_year.$today_mon.$today_day eq $year.$mon.$day) { # ¥  ӽϿ Ÿ 
			&plus_cnt("hour", $hour);
			&plus_system($ENV{'HTTP_USER_AGENT'});
		}
		else { # ¥ ƴϸ  Ÿ Ʈ Ұ!
			&update_db($year, $mon, $day, $hour);
		}
		print "Set-Cookie: $cook_name=OK;\r\n";
	}
}

sub update_db {
	my ($file_name, @date_list, $mon_total, @today_hour_cnt);
	my ($year, $mon, $day, $hour) = @_;
	
	# ο ¥ Է
	&lock("today_date");
	open(TODAY, ">$cnt_dir/today_date.cgi");
	print TODAY "$year.$mon.$day";
	close(TODAY);
	&unlock("today_date");

	# Ʈ ¥ īͼ($today_cnt) ð īͼ(@today_hour_cnt) .
	my $today_cnt = 0; 
	for(0..23) {
		my $hour = sprintf("%.2d", $_);
		open(CNT, "$cnt_dir/today_hour$hour.cgi");
		my $tmp_cnt = <CNT>;
		close(CNT);

		$today_hour_cnt[$_] = $tmp_cnt;
		&update_cnt("hour", $hour, $tmp_cnt);
		$today_cnt += $tmp_cnt;
		unlink("$cnt_dir/today_hour$hour.cgi");
	}

	# Ӽ Ʈ
	&update_cnt("total", "", $today_cnt);
	
	#  Ÿ Ʈ
	my $file_name = $today_year.$today_mon;

	open(DATA, "$cnt_dir/$file_name.cgi");
	chomp(@date_list = <DATA>);
	close(DATA);
	$mon_total = $date_list[0] + $today_cnt;
	
	&lock("$file_name");
	open(DATA, ">$cnt_dir/$file_name.cgi");
	print DATA "$mon_total\n";
	
	#  Ÿ Ʈ
	for(1..31) {
		#  ... 
		my $chk_day = ($day > $today_day) ? ($day - 1) : ($today_day); 
		if($_ == $today_day) {
			$date_list[$_] = join(":", @today_hour_cnt);
		}
		print DATA "$date_list[$_]\n";
		last if($_ == $chk_day);
	}
	close(DATA);
	&unlock("$file_name");
	
	#  Ÿ ϱ
	&back_up;
	
	#  Ÿ Ʈ
	$tmp_week = $week - 1;
	$tmp_week = 6 if($tmp_week < 0);
	$tmp_week = sprintf("%.2d", $tmp_week);
	&update_cnt("week", $tmp_week, $today_cnt);
	
	# OS/ Ÿ Ʈ
	my @os_brw = qw(win95 win98 winme winnt win2000 winxp mac unix sun os_etc ie4 ie5 ie6 ns4 ns6 ns7 mozilla kqr opr brw_etc);
	foreach $os_brw(@os_brw) {
		if(open(CNT, "$cnt_dir/today_$os_brw.cgi")) {
			my $plus_cnt = <CNT>;
			close(CNT);
			&update_cnt($os_brw, "", $plus_cnt);  
		}
		unlink("$cnt_dir/today_$os_brw.cgi");
	}
		
	# ӱ Ÿ Ʈ
	#my @c_code_list = glob("$cnt_dir/today_c_code_*.cgi");
	#õȿ globԼ .
	opendir(DIR , "$cnt_dir");
	my @c_code_list = grep(/today_c_code_.*\.cgi$/, readdir(DIR));
	closedir(DIR);	

	foreach $tc_code(@c_code_list) {
		open(DATA, "$cnt_dir/$tc_code");
		chomp(my $t_cnt = <DATA>);
		close(DATA);

		$tc_code =~ s/^today_//o;
		$tc_code =~ s/\.cgi$//o;
		&update_cnt($tc_code, "", $t_cnt);
		unlink("$cnt_dir/today_$tc_code.cgi");
	}		
		
	#   ī Ͻ.
	&plus_cnt("hour", $hour);
	&plus_system($ENV{'HTTP_USER_AGENT'});
}

sub update_cnt {
	my ($opt, $data, $plus_cnt) = @_;
	my $file_name = "$opt$data.cgi";

	open(DATA, "$cnt_dir/$file_name");
	my $cur_cnt = <DATA>;
	close(DATA);
	
	$cur_cnt += $plus_cnt;
	
	&lock($file_name);
	open(DATA, ">$cnt_dir/$file_name");
	print DATA $cur_cnt;
	close(DATA);
	&unlock($file_name);
}

sub back_up {
	my($file_name, $backup_num, @list);
	$file_name = "$today_year$today_mon";
	$backup_num = $day%10; # 10ϰ Ÿ  
	
	open(DATA, "$cnt_dir/$file_name.cgi");
	chomp(@list = <DATA>);
	close(DATA);
	
	&lock("back_up$backup_num");
	open(BACKUP, ">$cnt_dir/back_up$backup_num.cgi");
	print BACKUP "Backup date: $today_year.$today_mon.$today_day\n";
	print BACKUP join("\n", @list);
	close(BACKUP);
	&unlock("back_up$backup_num");
}

sub plus_cnt {
	my($opt, $data) = @_;
	my $file_name = "today_$opt$data";
	open(CNT, "$cnt_dir/$file_name.cgi");
	my $cnt_data = <CNT>;
	close(CNT);
	$cnt_data++;

	&lock("$file_name");
	open(CNT, ">$cnt_dir/$file_name.cgi");
	print CNT $cnt_data;
	close(CNT);
	&unlock("$file_name");
}

sub plus_system {
	my ($ua_data, $today) = @_;
	# OS Ÿ
	if((($ua_data =~ /Win95/i) || ($ua_data =~ /Windows 95/i)) && ($ua_data !~ /Powermarks/i)) {
		&plus_cnt("win95");
	}
	elsif($ua_data =~ /Win 9x 4.9|Windows ME/i) {
		&plus_cnt("winme");
	}
	elsif((($ua_data =~ /Windows/i) && ($ua_data =~ /Win98/i)) || ($ua_data =~ /Windows 98/i)) {
		&plus_cnt("win98");
	}
	elsif($ua_data =~ /Windows NT 5.0|Windows 2000/i) {
		&plus_cnt("win2000");
	}
	elsif($ua_data =~ /Windows NT 5.1|Windows XP/i) {
		&plus_cnt("winxp");
	}
	elsif($ua_data =~ /Windows NT/i) {
		&plus_cnt("winnt");
	}
	elsif($ua_data =~ /Mac_PowerPC|Macintosh/i) {
		&plus_cnt("mac");
	}
	elsif($ua_data =~ /UNIX|Linux/i) {
		&plus_cnt("unix");
	}
	elsif($ua_data =~ /SunOS/i) {
		&plus_cnt("sun");
	}
	else {
		&plus_cnt("os_etc");
		&plus_etc("os_etc_data");
	}

	#  Ÿ
	if($ua_data =~ /Opera/i) {
		&plus_cnt("opr");
	}
	elsif($ua_data =~ /Konqueror/i) {
		&plus_cnt("kqr");
	}
	elsif($ua_data =~ /MSIE 4/i) {
		&plus_cnt("ie4");
	}
	elsif($ua_data =~ /MSIE 5/i) {
		&plus_cnt("ie5");
	}
	elsif($ua_data =~ /MSIE 6/i) {
		&plus_cnt("ie6");
	}
	elsif(($ua_data =~ /Netscape6/i) && ($ua_data =~ /Gecko/i)) {
		&plus_cnt("ns6");
	}
	elsif(($ua_data =~ /Netscape\/7/i) && ($ua_data =~ /Gecko/i)) {
		&plus_cnt("ns7");
	}
	elsif($ua_data =~ /Gecko/i) {
		&plus_cnt("mozilla");
	}
	elsif(($ua_data =~ /Mozilla\/4/i) && ($ua_data !~ /Slurp|Zealbot|Powermarks|ZyBorg/i)) {
		&plus_cnt("ns4");
	}
	else {
		&plus_cnt("brw_etc");
		&plus_etc("brw_etc_data");
	}

	#  Ÿ
	require "./cgi_lib/get_c_code.cgi";
	my $c_code = &get_c_code($ENV{'REMOTE_ADDR'});
	&plus_cnt("c_code_", $c_code);
}

sub plus_etc {
	my (@etc_list, $last_line, $file_name, $date_val);
	$file_name = shift;
	$last_line = "#================================= LAST LINE =================================#";
	
	open(ETC, "$cnt_dir/$file_name.cgi");
	chomp(@etc_list = <ETC>);
	close(ETC);
	my ($min, $hour, $mday, $mon, $year);
	(undef, $min, $hour, $mday, $mon, $year, undef) = map {sprintf "%.2d", $_} localtime;
	$mon++;	
	$year += 1900;
	$date_val = "$year.$mon.$mday - $hour:$min";

	&lock("$file_name");
	open(ETC, ">$cnt_dir/$file_name.cgi");
	print ETC "$date_val ($ENV{'REMOTE_ADDR'}) : $ENV{'HTTP_USER_AGENT'}\n";
	for(0..98) { # 100α  ^^ 
		last if($etc_list[$_] eq $last_line);
		print ETC "$etc_list[$_]\n";
	}
	print ETC "$last_line\n";
	close(ETC);
	&unlock("$file_name");
}

return 1;