#----------------------------------------------------------------------#
# ̹  ̿  о Լ... *^^*
# Ǵ Ȯڸ: gif, jpg, jpeg, png, xbm 
# http://www.bloodyeck.com/wwwis/   Լ ... *^^*
#----------------------------------------------------------------------#
sub img_size {
	my $img_file = shift;
	my ($width, $height);
	
	if($img_file =~ /^http:\/\/.*/) { # ũ  .
		($width, $height) =	&urlsize("$img_file");
	}
	else {
		open(IMG, "$img_file");
		binmode IMG; # for crappy MS OSes - Win/Dos/NT use is NOT SUPPORTED
		if ($img_file =~ /\.jpg$/i || $img_file =~ /\.jpeg$/i) {
			($width, $height) = &jpegsize(\*IMG);
		} 
		elsif($img_file =~ /\.gif$/i) {
			($width, $height) = &gifsize(\*IMG);
		} 
		elsif($img_file =~ /\.xbm$/i) {
			($width, $height) = &xbmsize(\*IMG);
		} 
		elsif($img_file =~ /\.png$/i) {
			($width, $height) = &pngsize(\*IMG);
		} 

		close(IMG);
	}

	return ($width, $height);
}

sub gifsize {
  my($GIF) = @_;
  my($type,$a,$b,$c,$d,$s)=(0,0,0,0,0,0);

  if(defined( $GIF )		&&
     read($GIF, $type, 6)	&&
     $type =~ /GIF8[7,9]a/	&&
     read($GIF, $s, 4) == 4	){
    ($a,$b,$c,$d)=unpack("C"x4,$s);
    return ($b<<8|$a,$d<<8|$c);
  }
  return (0,0);
}

sub jpegsize {
  my($JPEG) = @_;
  my($done)=0;
  my($c1,$c2,$ch,$s,$length, $dummy)=(0,0,0,0,0,0);
  my($a,$b,$c,$d);

  if(defined($JPEG)		&&
     read($JPEG, $c1, 1)	&&
     read($JPEG, $c2, 1)	&&
     ord($c1) == 0xFF		&&
     ord($c2) == 0xD8		){
    while (ord($ch) != 0xDA && !$done) {
      # Find next marker (JPEG markers begin with 0xFF)
      # This can hang the program!!
      while (ord($ch) != 0xFF) { return(0,0) unless read($JPEG, $ch, 1); }
      # JPEG markers can be padded with unlimited 0xFF's
      while (ord($ch) == 0xFF) { return(0,0) unless read($JPEG, $ch, 1); }
      # Now, $ch contains the value of the marker.
      if ((ord($ch) >= 0xC0) && (ord($ch) <= 0xC3)) {
	return(0,0) unless read ($JPEG, $dummy, 3);
	return(0,0) unless read($JPEG, $s, 4);
	($a,$b,$c,$d)=unpack("C"x4,$s);
	return ($c<<8|$d, $a<<8|$b );
      } else {
	# We **MUST** skip variables, since FF's within variable names are
	# NOT valid JPEG markers
	return(0,0) unless read ($JPEG, $s, 2);
	($c1, $c2) = unpack("C"x2,$s);
	$length = $c1<<8|$c2;
	last if (!defined($length) || $length < 2);
	read($JPEG, $dummy, $length-2);
      }
    }
  }
  return (0,0);
}

sub xbmsize {
  my($XBM) = @_;
  my($input)="";

  if( defined( $XBM ) ){
    $input .= <$XBM>;
    $input .= <$XBM>;
    $input .= <$XBM>;
    $_ = $input;
    if( /.define\s+\S+\s+(\d+)\s*\n.define\s+\S+\s+(\d+)\s*\n/i ){
      return ($1,$2);
    }
  }
  return (0,0);
}

#  pngsize : gets the width & height (in pixels) of a png file
# cor this program is on the cutting edge of technology! (pity it's blunt!)
#  GRR 970619:  fixed bytesex assumption
sub pngsize {
  my($PNG) = @_;
  my($head) = "";
# my($width, $height);
  my($a, $b, $c, $d, $e, $f, $g, $h)=0;

  if(defined($PNG)				&&
     read( $PNG, $head, 8 ) == 8		&&
     $head eq "\x89\x50\x4e\x47\x0d\x0a\x1a\x0a" &&
     read($PNG, $head, 4) == 4			&&
     read($PNG, $head, 4) == 4			&&
     $head eq "IHDR"				&&
     read($PNG, $head, 8) == 8 			){
#   ($width, $height)=unpack("I"x2,$head);   # doesn't work on little-endian machines
#   return ($width, $height);
    ($a,$b,$c,$d,$e,$f,$g,$h)=unpack("C"x8,$head);
    return ($a<<24|$b<<16|$c<<8|$d, $e<<24|$f<<16|$g<<8|$h);
  }
  return (0,0);
}


sub urlsize {
  use Socket;

  my($five) = @_;
  my($dummy, $server, $url);
  my($c1, $c2, $c3, $c4)=(0,0,0,0);

  my( $width, $height) = (0,0);

  if( $Proxy =~ /\S+/ ){
	($dummy, $dummy, $server, $url)     = split(/\//, $Proxy, 4);
	$url=$five;
  } 
  else {
	($dummy, $dummy, $server, $url) = split(/\//, $five, 4);
	$url= '/' . $url;
  }

  my($them,$port) = split(/:/, $server);
  my( $iaddr, $paddr, $proto );

  $port = 80 unless $port;
  $them = 'localhost' unless $them;

  $_=$url;
  if( /gif/i || /jpeg/i || /jpg/i || /xbm/i || /png/i ){

    $iaddr= inet_aton( $them );
    $paddr= sockaddr_in( $port, $iaddr );
    $proto=getprotobyname('tcp');

    # Make the socket filehandle.

    if(socket(IMG, PF_INET, SOCK_STREAM, $proto) && connect(IMG,$paddr) ){
      # Set socket to be command buffered.
      select(IMG); $| = 1; select(STDOUT);

      my $str=("GET $url HTTP/1.1\n".
	       "User-Agent: Mozilla/4.08 [en] (WWWIS)\n".
	       "Accept: */*\n".
	       "Connection: close\n".
	       "Host: $them\n\n");

      print IMG $str;

      # we're looking for \n\r\n\r
	  while ((ord($c1) != 10) || (ord($c2) != 13) || (ord ($c3) != 10) || (ord($c4) != 13)) {
		$c4 = $c3;
		$c3 = $c2;
		$c2 = $c1;
		read(IMG, $c1, 1);
      }
     if ($url =~ /\.jpg$/i || $url =~ /\.jpeg$/i) {
		($width, $height) = &jpegsize(\*IMG);
     } 
	 elsif($url =~ /\.gif$/i) {
		($width, $height) = &gifsize(\*IMG);
     }
	 elsif($url =~ /\.xbm$/i) {
		($width, $height) = &xbmsize(\*IMG);
     }
	 elsif($url =~ /\.png$/i) {
		($width, $height) = &pngsize(\*IMG);
     }
	 else {
		#print "$url is not gif, jpeg, xbm or png (or has stupid name)";
     }

      close ( IMG );
    } else {
      # there was a problem
      # print "ERROR: $!";
    }
  } 

  return ($width, $height);
}


return 1;