#----------------------------------------------------------------------#
# ȸ  Լ... *^^*
#----------------------------------------------------------------------#

sub mem_info {
	my %MEM;
	my ($mem_id, $mem_dir, $opt) = @_;
	
	$mem_dir ||= "mem_data";
	open(INFO, "$main_dir/member/$mem_dir/$mem_id.cgi");
	foreach (<INFO>) { 
		if(/([^=]*?)\s*=\s*(.*?)\s*$/) {
			$MEM{$1} = $2;
		}
	}
	close(INFO);

	$MEM{'group'} ||= "basic";
	$MEM{'mem_icon'} = "" if($CONF{'no_name_icon'});
	
	# home http:// ...
	if($MEM{'home'} && ($MEM{'home'} !~ /^http:\/\//)) {
		$MEM{'home'} = "http://".$MEM{'home'};
	}		

	if($opt eq "") {
		return \%MEM;
	}
	else{
		$MEM{'nickname'} = $MEM{'name'}	if($CONF{'real_name'});

		if($opt eq "pwd") {
			return $MEM{'pwd'};
		}
		elsif($opt eq "group") {
			return $MEM{'group'};
		}
		elsif($opt eq "input") {
			return @MEM{'pwd', 'nickname', 'mail', 'home'}; # ؽ ̽
		}
		elsif($opt eq "online") {
			return @MEM{'mem_icon', 'nickname', 'home', 'group', 'icon_wh'}; # ؽ ̽
		}
		elsif($opt eq "mem_list") {
			return @MEM{'nickname', 'name', 'mail', 'home', 'date', 'cmt', 'mem_icon', 'group', 'icon_wh'};
		}
		elsif($opt eq "home_mail") {
			return @MEM{'mail', 'home'};
		}
		elsif($opt eq "del_mem") {
			return @MEM{'screet', 'ip', 'home', 'mail', 'birth_date', 'mem_icon', 'group', 'mem_photo'};
		}
		elsif($opt eq "join_mail") {
			return @MEM{'name', 'mail'};
		}
		elsif($opt eq "sendmail") {
			return @MEM{'nickname', 'mail'};
		}
		elsif($opt eq "view_info"){
			return @MEM{'nickname', 'name', 'mail', 'home', 'ok_mail', 'date', 'cmt', 'group'};
		}
		elsif($opt eq "loss_pwd") {
			return @MEM{'pwd', 'mail', 'name'};
		}
		elsif($opt eq "mailling") {
			return @MEM{'mail', 'ok_mail', 'group'};
		}
		elsif($opt eq "mem_date") {
			return $MEM{'date'};
		}
		elsif($opt eq "mem_icon") {
			return $MEM{'mem_icon'} if(-e "$main_dir/member/mem_icon/$MEM{'mem_icon'}");
		}
		elsif($opt eq "icon_grp") {
			return @MEM{'mem_icon', 'group', 'icon_wh'} if(-e "$main_dir/member/mem_icon/$MEM{'mem_icon'}");
		}
		elsif($opt eq "icon_sign") {
			require "./cgi_lib/conv_cmt.cgi";
			my $mem_icon = $MEM{'mem_icon'} if(-e "$main_dir/member/mem_icon/$MEM{'mem_icon'}");
			my $mem_photo = $MEM{'mem_photo'} if(-e "$main_dir/member/mem_photo/$MEM{'mem_photo'}");
			my ($html_ok, $auto_br, $sign) = split(/\|/, $MEM{'sign'});
			my $sign_val = &conv_cmt("view", $sign, $html_ok, $auto_br);	
			return ($mem_icon, $sign_val, $mem_photo, $MEM{'group'}, $MEM{'icon_wh'}, $MEM{'photo_wh'});
		}
	}
}

return 1;