require "./cgi_lib/load_charset.cgi";
require "./cgi_lib/load_css.cgi";
require "./cgi_lib/load_html.cgi"; # conv_cmt.cgi ҷ...
require "./cgi_lib/read_idx.cgi";
require "./cgi_lib/read_num.cgi";
require "./cgi_lib/load_msg.cgi";
require "./cgi_lib/cut_length.cgi";
require "./cgi_lib/read_gul.cgi";
require "./cgi_lib/file_type.cgi";
require "./cgi_lib/comma.cgi";
require "./cgi_lib/page_move.cgi";
require "./cgi_lib/encode.cgi";
require "./cgi_lib/etc_cnt.cgi" if($CONF{'use_etc'}); # etc_cnt() Լ ϱ ...
require "./cgi_lib/img_size.cgi";
require "./cgi_lib/img_wh.cgi";

#---------------------------------------------------------------------#
#  ȭ ... *^^*
#---------------------------------------------------------------------#
sub display {
	local $opt = shift; #view Լ  ɼ... ^^
	
	my(@html, $charset, $list, $css, $hidden_val, $up_html, $down_html, $multi_del, $page_move, $prog_info, $cate_view);
	local ($page, $total_page, @idx, $page_idx, %MAIN_TBL, $total_cnt, $all_cnt, $search_opt, $cate_opt, $sort_opt);
	$page = $FORM{'page'};
	$page ||= 1;
	%MAIN_TBL = &load_msg("$CONF{'lang'}", "main_tbl");
	
	if($FORM{'category'}) {
		my $cate_name = &encode($FORM{'category'});
		$cate_opt = "&category=$cate_name";
	}

	if($FORM{'sort'}) {
		$sort_opt = "&sort=$FORM{'sort'}";
	}

	if(($opt eq "search") || ($FORM{'keyword'} ne "")) { # ˻ ε ...
		my ($temp_keyword);
		$temp_keyword = $FORM{'keyword'};
		$temp_keyword =~ s/ //g;
		if($temp_keyword eq "") {
			require "./cgi_lib/java_err.cgi";
			&java_err("blank_keyword");
		}
		require "./cgi_lib/search_idx.cgi";
		@idx = &search_idx;
		$search_opt = "&gubun=$FORM{'gubun'}&keyword=$FORM{'keyword'}&start_num=$FORM{'start_num'}" if($FORM{'keyword'});
	}
	else {
		if($FORM{'category'}) {
			@idx = &read_idx("category/$FORM{'category'}");
		}
		else{
			if($FORM{'sort'}) {
				@idx = &read_idx;
			}
			else {
				@idx = &read_idx("$page");
				$page_idx = "ok" if(-e "$data_dir/idx/$page.txt"); # load_list.cgi Ͽ ... *^^*
			}

		}
	}

	if($FORM{'sort'}) {
		require "./cgi_lib/sort_idx.cgi";
		@idx = &sort_idx("$FORM{'sort'}");
	}

	require "./cgi_lib/prog_info.cgi";
	$prog_info = &prog_info("$version_info", "$last_update");

	open(HTML, "$html_skin/view_list.htm");
	@html = <HTML>;
	close(HTML);
	
	$charset = &load_charset("$CONF{'lang'}");
	$css = &load_css("$CONF{'html_skin'}");
	
	#   
	local($face_wh, $reply_wh, $mod_wh, $del_wh, $vote_wh, $list_wh, $post_wh, $print_wh, $mail_wh, $now_wh, $home_wh, $gul_wh, $lock_wh, $write_wh, $admin_wh, $next_wh);
	if($opt eq "view" || $opt eq "multi") {
		$face_wh = &img_wh("face.gif");
		$reply_wh = &img_wh("reply.gif");
		$mod_wh = &img_wh("modify.gif");
		$del_wh = &img_wh("delete.gif");
		$vote_wh = &img_wh("vote.gif");
		$list_wh = &img_wh("list.gif");
		$slist_wh = &img_wh("search_list.gif") if($FORM{'keyword'});
		$post_wh = &img_wh("toemail.gif");
		$print_wh = &img_wh("print.gif");
		$mail_wh = &img_wh("mail.gif");
		$now_wh = &img_wh("now.gif");
	}
	$home_wh = &img_wh("home.gif");
	$gul_wh = &img_wh("gul.gif");
	$lock_wh = &img_wh("lock.gif");
	$write_wh = &img_wh("write.gif");
	$admin_wh = &img_wh("admin.gif");
	$next_wh = &img_wh("next.gif");

	if($opt eq "view") {
		# history.go ī... *^^*
		$FORM{'go_cnt'}++;
		require "./cgi_skin/$CONF{'cgi_skin'}/view.cgi";
		$view_article = &view("$FORM{'gul'}");
	}
	elsif($opt eq "multi") {
		# history.go ī... *^^*
		$FORM{'go_cnt'}++;
		my (@multi, $temp_num, $chk_val);
		$temp_num = 0;
		for (0..$CONF{'list_num'}) {
			$chk_val = "chk_$_";
			next if($FORM{$chk_val} eq "");
			$multi[$temp_num] = $FORM{$chk_val};
			$temp_num++;
		}
		require "./cgi_skin/$CONF{'cgi_skin'}/multi_view.cgi";
		$view_article = &multi_view(@multi);
	}
	
	unless(($CONF{'list_view'} ne "on") && ($opt eq "view")) {
		require "./cgi_skin/$CONF{'cgi_skin'}/load_list.cgi";
		$list = &load_list;
	}

	$hidden_val = "<input type=hidden name=action value=multi>\n";
	$hidden_val .= "<input type=hidden name=id value=$FORM{'id'}>\n"; 
	$hidden_val .= "<input type=hidden name=page value=$page>\n";
	$hidden_val .= "<input type=hidden name=category value=$FORM{'category'}>\n";
	$hidden_val .= "<input type=hidden name=sort value=$FORM{'sort'}>\n";
	$hidden_val .= "<input type=hidden name=go_cnt value=$FORM{'go_cnt'}>\n";

	if($FORM{'keyword'}) {
		$hidden_val .= "<input type=hidden name=gubun value=$FORM{'gubun'}>\n";
		$hidden_val .= "<input type=hidden name=keyword value=$FORM{'keyword'}>\n";
		$hidden_val .= "<input type=hidden name=start_num value=$FORM{'start_num'}>\n";
	}

	$up_html = &load_html("up");
	$up_html .= "<table border=0 cellpadding=0 cellspacing=0 width=$CONF{'width'} align=$CONF{'align'}><tr><td>\n";
	$down_html = "</td></tr></table>";
	$down_html .= &load_html("down");

	# īװ ϱ... *^^*
	if($CONF{'use_cate'} && ($CONF{'cate_list'} eq "side")) {
		unless(($CONF{'list_view'} ne "on") && ($opt eq "view")) {
			my($cate_list, $cate_sub);
			require "./cgi_skin/$CONF{'cgi_skin'}/cate_list.cgi";
			$cate_list = &cate_list("$FORM{'category'}");
			if($CONF{'img_head'}) {
				$cate_sub = "<td align=center height=18 background=$img_url/head_img/$CONF{'head_img'}/hd_bg.gif><img src=$img_url/head_img/$CONF{'head_img'}/hd_category.gif border=0></td>";
			}
			else {
				$cate_sub = "<td align=center><nobr><font color=$CONF{'hfont_color'}>$MAIN_TBL{'cate_sub'}</font></nobr></td>";
			}
			open(CATE, "$html_skin/cate_view.htm");
			foreach (<CATE>) {
				$_ =~ s/\.\/img/$img_skin/eo;
				$_ =~ s/<!--TR_COLOR-->/$CONF{'tr_color01'}/eo;
				$_ =~ s/<!--HEAD_COLOR-->/$CONF{'head_color'}/g;
				$_ =~ s/<!--HFONT_COLOR-->/$CONF{'hfont_color'}/eo;
				$_ =~ s/<!--CATE_SUB-->/$cate_sub/eo;
				$_ =~ s/<!--CATE_SUB-->/$MAIN_TBL{'cate_sub'}/eo;
				$_ =~ s/<!--CATE_LIST-->/$cate_list/eo;
				$cate_view .= $_;
			}
			close(CATE);
		}
	}
	
	my($write_icon, $wicon_hide, $admin_icon, $prev_icon, $next_icon, $prev_page, $next_pgae, $page_info);
	$prev_page = $page - 1;
	$next_page = $page + 1;
	unless(($CONF{'list_view'} ne "on") && ($opt eq "view")) {
		unless($CONF{'img_head'}) {
			$tbl_head = "<table bgcolor=$CONF{'head_color'} width=100% border=0 cellpadding=0 cellspacing=0>\n";
			$tbl_head .= "<tr><td><img src=$img_skin/zero.gif width=0 height=2></td></tr></table>\n";
		}

		require "./cgi_lib/member/login_btn.cgi";
		($login_icon, $join_icon) = &login_btn; # α   ҷ...

		$write_icon = "<a href=$cgi_url?id=$FORM{'id'}&action=input_form&page=$FORM{'page'}$sort_opt$cate_opt$search_opt><img src=$img_skin/write.gif $write_wh border=0 alt=\"$MAIN_TBL{'write_msg'}\"></a>"; 
		$admin_icon = "<a href=$cgi_url?id=$FORM{'id'}&action=input_pwd&load_act=admin_form$sort_opt$cate_opt$search_opt><img src=$img_skin/admin.gif $admin_wh border=0 alt=\"$MAIN_TBL{'admin_msg'}\"></a>"; 
		$prev_icon = ($page == 1) ? "<img src=$img_skin/prev.gif border=0 $next_wh alt=\"$MAIN_TBL{'first_page'}\">" : "<a href=$cgi_url?id=$FORM{'id'}&page=$prev_page$sort_opt$cate_opt$search_opt><img src=$img_skin/prev.gif $next_wh border=0 alt=\"$MAIN_TBL{'prev_page'}\"></a>"; 
		$next_icon = ($page == $total_page) ? "<img src=$img_skin/next.gif $next_wh border=0 alt=\"$MAIN_TBL{'last_page'}\">" : "<a href=$cgi_url?id=$FORM{'id'}&page=$next_page$sort_opt$cate_opt$search_opt><img src=$img_skin/next.gif $next_wh border=0 alt=\"$MAIN_TBL{'next_page'}\"></a>"; 
		if($FORM{'keyword'}) {
			$page_info = "$MAIN_TBL{'search_info'}<br>";
			$page_info =~ s/<!--KEYWORD-->/"<font color=$CONF{'date_color'}>$FORM{'keyword'}<\/font>"/eo;
		}
		$page_info .= "$MAIN_TBL{'page_info'}";
		$total_cnt = &comma($total_cnt);
		$page_info =~ s/<!--TOTAL-->/"<font color=$CONF{'date_color'}>$total_cnt<\/font>"/eg;
		$page_info =~ s/<!--CUR_PAGE-->/"<font color=$CONF{'read_color'}>$page<\/font>"/eo;
		$page_info =~ s/<!--TOTAL_PAGE-->/"<font color=$CONF{'down_color'}>$total_page<\/font>"/eo;
		$multi_del = "<input type=image name=multi_del src=$img_skin/multi_del.gif alt=\"$MAIN_TBL{'multi_del'}\" border=0>" if($CONF{'chk_view'} eq "on");
		$page_move = &page_move("$page", "$total_page");

		if($CONF{'search_view'}) {
			require "./cgi_skin/$CONF{'cgi_skin'}/search_form.cgi";
			$search_form = &search_form("$FORM{'keyword'}","$FORM{'category'}");
		}
	}

	# Copyright κ... ^^;
	unless($customer == 1) { # ı ... *^^*
		open(INFO, "$main_dir/img/img_skin/$CONF{'img_skin'}/img_info.txt");
		my $img_info = <INFO>;
		close(INFO);
		
		if(($CONF{'skin_info'}) || $img_info) {
			$copyright = "<a href=http://www.spfamily.com/ target=_blank><font color=gray>Created by spfamily.com</font></a>";
			$copyright .= " <font color=gray>/</font> $CONF{'skin_info'}" if($CONF{'skin_info'});
			$copyright .= " <font color=gray>/</font> $img_info" if($img_info);
		}
	}

	print "Content-type:text/html\n\n"; #HTML  ȭ 	
	foreach (@html) {
		$_ =~ s/\.\/img/$img_skin/eo;
		$_ =~ s/<!--PROG_INFO-->/$prog_info/eo;
		$_ =~ s/<!--CHARSET-->/$charset/eo;
		$_ =~ s/<!--STYLE-->/$css/eo;
		$_ =~ s/<!--BGCOLOR-->/$CONF{'bgcolor'}/eo;
		$_ =~ s/<!--BACKGROUND-->/$CONF{'background'}/eo;
		$_ =~ s/<!--TOPMARGIN-->/$CONF{'topmargin'}/eo;
		$_ =~ s/<!--LEFTMARGIN-->/$CONF{'leftmargin'}/eo;
		$_ =~ s/<!--VIEW_ARTICLE-->/$view_article/eo;
		$_ =~ s/<!--WRITE-->/$write_icon/eo;
		$_ =~ s/<!--LOGIN-->/$login_icon/eo;
		$_ =~ s/<!--JOIN-->/$join_icon/eo;
		$_ =~ s/<!--ADMIN-->/$admin_icon/eo if($admin_icon);
		$_ =~ s/<!--PAGE_INFO-->/$page_info/eo if($page_info);
		$_ =~ s/<!--PREV-->/$prev_icon/eo if($prev_icon);
		$_ =~ s/<!--NEXT-->/$next_icon/eo if($next_icon);
		$_ =~ s/<!--HEAD_COLOR-->/$CONF{'head_color'}/eo;
		$_ =~ s/<!--HFONT_COLOR-->/$CONF{'hfont_color'}/eo;
		$_ =~ s/<!--HIDDEN-->/$hidden_val/eo;
		$_ =~ s/<!--UP_HTML-->/$up_html/eo;
		$_ =~ s/<!--CATE_VIEW-->/$cate_view/eo;
		$_ =~ s/<!--TBL_HEAD-->/$tbl_head/eo if($tbl_head); 
		$_ =~ s/<!--LIST-->/$list/eo if($list);
		$_ =~ s/<!--MULTI_DEL-->/$multi_del/eo if($multi_del);
		$_ =~ s/<!--PAGE_MOVE-->/$page_move/eo if($page_move);
		$_ =~ s/<!--SEARCH-->/$search_form/eo if($search_form);
		$_ =~ s/<!--COPYRIGHT-->/$copyright/eo unless(($CONF{'list_view'} ne "on") && ($opt eq "view"));
		$_ =~ s/<!--DOWN_HTML-->/$down_html/eo;
		print $_;
	}

}

return 1;