#!/usr/bin/perl

#----------------------------------------------------#
# SPBOARD PRO ڵ ¾ α׷... *^^*
#----------------------------------------------------#

umask(000);

require "./path.cgi";
require "./cgi_lib/parse.cgi";
require "./cgi_lib/load_msg.cgi";
require "./cgi_lib/jcode.pl"; # for the Japanese language 
require "./cgi_lib/load_charset.cgi";

&parse;

%SETUP = &load_msg("$FORM{'lang'}", "setup");
$data_dir = "$main_dir/id";
$mem_dir = "$main_dir/member";
$title = "::: SET UP OF SPBOARD PRO :::";
$charset = &load_charset("$FORM{'lang'}");
$charset ||= "EUC-KR";
$font_face = $SETUP{'basic_font'} ? "$SETUP{'basic_font'}" : "tahoma";

# img_wh.cgi  
$CONF{'img_skin'} = "board_default";
$CONF{'head_img'} = "soya_st_white";

if(-e "$main_dir/id/admin_conf.cgi") {
	my $err_msg = "Already terminated setup process!!!\\n\\n̹ ¾ Ϸ Դϴ... *^^*";
	print "Content-type: text/html\n\n";
	print "<script>\n";
	print "window.alert('$err_msg')\n";
	print "history.go(-1)\n";
	print "</script>\n";
	exit;
}

if($FORM{'action'} eq "") {
	&select_lang;
}
if($FORM{'action'} eq "before_setup") {
	&before_setup;
}
elsif($FORM{'action'} eq "input_form") {
	&input_form;
}
elsif($FORM{'action'} eq "make_files"){
	&make_files;
}

sub select_lang {
	$CONF{'lang'} = "Korean"; # ʱ  
	
	my (@lang, $lang_val, $sel_lang);
	opendir(LANG, "$main_dir/lang");
	@lang = sort (grep (!/^\.{1,2}$/, readdir(LANG)));
	closedir(LANG);
	$lang_val = "<select name=lang>\n";
	foreach (@lang) {
		my $sel_lang = "selected" if($_ eq "$CONF{'lang'}");
		$lang_val .= "<option value=\"$_\" $sel_lang>$_\n";
	}
	$lang_val .= "</select>";
	&head;
		
	print <<"    __HTML__";
		<form method=post action=./setup.cgi>
		<input type=hidden name=action value=before_setup>
		<table border=1 bgcolor=#2E50A6 cellpadding=12 cellspacing=0 bordercolordark=white bordercolorlight=black valign=middle align=center>
		<tr>
			<td class=cont>
				<font color=white>Ͻ   ּ.<br>Select your the national language.</font>
				<br><br>
				$lang_val <input type=submit value="::: SUBMIT(Ȯ ) :::">
			</td>
		</tr>
		</table>
		</form>
    __HTML__

	&foot;
}


sub before_setup {
	open(BS, "$main_dir/lang/$FORM{'lang'}/before_setup.txt");
	chomp(@bs_msg = <BS>);
	close(BS);

	&head;
		
	print <<"    __HTML__";
		<script language=javascript>
			function chk_ok() {
				var ok_val = document.form.ok.checked;
				var ok_msg = "$SETUP{'consent_setup'}";

				if(ok_val != true) {
					if(confirm(ok_msg)) {
						document.form.ok.checked = true;
						return true;
					}
					else{
						return false;
					}
				}
			}
		</script>
		<form name=form>
		<table border=0><tr><td colspan=2>
		<table border=1 cellpadding=12 cellspacing=0 bordercolordark=white bordercolorlight=black valign=middle align=center>
		<tr>
			<td class=cont bgcolor=#2E50A6>
				<textarea rows=16 cols=67 style="background-color:#2E50A6;color:white;scrollbar-face-color: #2E50A6; scrollbar-shadow-color: #004D73; scrollbar-highlight-color: #F2FEFF; scrollbar-3dlight-color: #E6FFF7; scrollbar-darkshadow-color: #001966; scrollbar-track-color: #2E50A6; scrollbar-arrow-color: #F2FEFF;" class=cont>
    __HTML__
	
	foreach (@bs_msg) {
		print "$_\n";
	}

	print <<"    __HTML__";			
				</textarea>
			</td>
		</tr>	
		</table>
		</td></tr>
		<tr>
			<td><input type=checkbox name=ok> $SETUP{'consent_setup'}</td>
			<td align=right>
				<a href="./setup.cgi?action=input_form&lang=$FORM{'lang'}" onClick="return chk_ok();"><img src=$main_url/img/img_skin/board_default/submit.gif border=0></a><a href="javascript:history.go(-1)"><img src=$main_url/img/img_skin/board_default/cancel.gif  border=0></a>
			</td>
		</tr>
		</table>
		</form>
		<br><br>
    __HTML__

	&foot;
}

sub input_form {
	&head;
		
	print <<"    __HTML__";
	<script language=JavaScript> <!--
		function check_mail(cg) {
			mail01 = /[^@]+@[A-Za-z0-9_-]+[.]+[A-Za-z]+/;
			mail02 = /[^@]+@[A-Za-z0-9_-]+[.]+[A-Za-z0-9_-]+[.]+[A-Za-z]+/;
			mail03 = /[^@]+@[A-Za-z0-9_-]+[.]+[A-Za-z0-9_-]+[.]+[A-Za-z0-9_-]+[.]+[A-Za-z]+/;

			if(mail01.test(cg.value)) return true;;
			if(mail02.test(cg.value)) return true;
			if(mail03.test(cg.value)) return true;

			return false;
		}

		function chk_pwd() {
			if(document.form.admin_name.value == ""){
				alert("$SETUP{'blank_name'}");
				document.form.admin_name.focus();
				return true;
			}
			
			if(document.form.admin_email.value != ""){
				f_val = document.form.admin_email;
				if(!check_mail(f_val)) { 
					alert("$SETUP{'bad_email'}"); 
					document.form.admin_email.focus();
					return true; 
				}
			}

			if(document.form.font_face.value == ""){
				alert("$SETUP{'blank_font_face'}");
				document.form.font_face.focus();
				return true;
			}
			
			if(document.form.admin_pwd01.value == ""){
				alert("$SETUP{'blank_pwd'}");
				document.form.admin_pwd01.focus();
				return true;
			}
		
			if(document.form.admin_pwd01.value != document.form.admin_pwd02.value){
				alert("$SETUP{'no_same_pwd'}");
				document.form.admin_pwd02.focus();
				return true;
			}
			document.form.submit();
		}

	// -->
	</script>

		<form name=form method=post action=./setup.cgi onSubmit="chk_pwd();return false">
		<input type=hidden name=action value=make_files>
		<input type=hidden name=lang value="$FORM{'lang'}">
		<table border=1 cellpadding=3 cellspacing=0 bordercolordark=white bordercolorlight=black align=center>
		<tr bgcolor=#2E50A6><td colspan=4 align=center style="padding:5px"><font color=white>$SETUP{'input_msg'}</font></td></tr>
		<tr><td width=92>$SETUP{'admin_name'}</td><td><input type=text size=17 name=admin_name></td>
			<td width=92>$SETUP{'admin_email'}</td><td><input type=text size=17 name=admin_email></td></tr>
		<tr><td>$SETUP{'admin_pwd'}</td><td><input type=password size=17 name=admin_pwd01></td>
			<td>$SETUP{'pwd_confirm'}</td><td><input type=password size=17 name=admin_pwd02></td></tr>
		<tr><td>$SETUP{'admin_url'}</td><td colspan=3><input type=text size=53 name=admin_url value="http://localhost"></td></tr>		
		<tr><td>$SETUP{'img_url'}</td><td colspan=3 class=cont><input type=text size=53 name=img_url value="http://localhost/spboard/img"><br>$SETUP{'img_info'}</td></tr>
		<tr><td>$SETUP{'font_face'}</td><td><input type=text size=17 name=font_face value="$SETUP{'basic_font'}"></td>
			<td colspan=2 align=center><input type=submit value="          $SETUP{'submit'}          "></td></tr>
		</table>
		</form>
    __HTML__

	&foot;
}

sub make_files {
	# ȸ 丮 ... *^^*
	mkdir("$mem_dir",0777);
	mkdir("$mem_dir/mem_data",0777);
	mkdir("$mem_dir/bad_data",0777);
	mkdir("$mem_dir/mem_cnt",0777);
	mkdir("$mem_dir/screet_num",0777);
	mkdir("$mem_dir/recent",0777);
	mkdir("$mem_dir/message",0777);
	mkdir("$mem_dir/mem_icon", 0777);
	mkdir("$mem_dir/mem_photo", 0777);
	mkdir("$mem_dir/birth_date", 0777);
	mkdir("$mem_dir/mem_grp", 0777);
	mkdir("$mem_dir/mem_grp/ready_data", 0777);

	# ȸ ̵ 丮 б  HTML  ... *^^*
	foreach ("default", "index") {
		open(HTML, ">$mem_dir/mem_data/$_.htm");
		print HTML "<script>\n";
		print HTML "window.alert('Access Reject!!! *^^*')\n";
		print HTML "history.go(-1)\n";
		print HTML "</script>";
		close(HTML);

		open(HTML, ">$mem_dir/bad_data/$_.htm");
		print HTML "<script>\n";
		print HTML "window.alert('Access Reject!!! *^^*')\n";
		print HTML "history.go(-1)\n";
		print HTML "</script>";
		close(HTML);

		open(HTML, ">$mem_dir/mem_cnt/$_.htm");
		print HTML "<script>\n";
		print HTML "window.alert('Access Reject!!! *^^*')\n";
		print HTML "history.go(-1)\n";
		print HTML "</script>";
		close(HTML);

		open(HTML, ">$mem_dir/screet_num/$_.htm");
		print HTML "<script>\n";
		print HTML "window.alert('Access Reject!!! *^^*')\n";
		print HTML "history.go(-1)\n";
		print HTML "</script>";
		close(HTML);	

		open(HTML, ">$mem_dir/recent/$_.htm");
		print HTML "<script>\n";
		print HTML "window.alert('Access Reject!!! *^^*')\n";
		print HTML "history.go(-1)\n";
		print HTML "</script>";
		close(HTML);	

		open(HTML, ">$mem_dir/message/$_.htm");
		print HTML "<script>\n";
		print HTML "window.alert('Access Reject!!! *^^*')\n";
		print HTML "history.go(-1)\n";
		print HTML "</script>";
		close(HTML);	

		open(HTML, ">$mem_dir/mem_icon/$_.htm");
		print HTML "<script>\n";
		print HTML "window.alert('Access Reject!!! *^^*')\n";
		print HTML "history.go(-1)\n";
		print HTML "</script>";
		close(HTML);	

		open(HTML, ">$mem_dir/mem_photo/$_.htm");
		print HTML "<script>\n";
		print HTML "window.alert('Access Reject!!! *^^*')\n";
		print HTML "history.go(-1)\n";
		print HTML "</script>";
		close(HTML);	

		open(HTML, ">$mem_dir/mem_grp/$_.htm");
		print HTML "<script>\n";
		print HTML "window.alert('Access Reject!!! *^^*')\n";
		print HTML "history.go(-1)\n";
		print HTML "</script>";
		close(HTML);	

		open(HTML, ">$mem_dir/mem_grp/ready_data/$_.htm");
		print HTML "<script>\n";
		print HTML "window.alert('Access Reject!!! *^^*')\n";
		print HTML "history.go(-1)\n";
		print HTML "</script>";
		close(HTML);	
	}

	# ȸ ȯ漳  .
	unless(-e "$mem_dir/conf.cgi") {
		require "./cgi_lib/load_msg.cgi";
		my %MEM = &load_msg("$FORM{'lang'}", "member");

		open(MC, ">$mem_dir/conf.cgi");
		print MC "opt_juso = on\n";
		print MC "opt_screet = on\n";
		print MC "opt_birth = on\n";
		print MC "opt_pcs = on\n";
		print MC "opt_tel = on\n";
		print MC "opt_sign = on\n";
		print MC "join_info = |on|$MEM{'default_join_info'}\n";
		print MC "join_msg = |on|$MEM{'default_join_msg'}\n";
		close(MC);
	}

	# ȸ ׷ ε   - Ϲȸ׷ ߰.
	unless(-e "$mem_dir/grp_idx.cgi") {
		open(GRP, ">$mem_dir/grp_idx.cgi");
		print GRP "basic = $SETUP{'basic_mem'}\n";
		close(GRP);
	}

	# ȸ ׷ ε   - Ϲȸ׷ ߰.
	unless(-e "$mem_dir/mem_grp/basic.cgi") {
		open(BM, ">$mem_dir/mem_grp/basic.cgi");
		print BM "\n";
		close(BM);
	}

	# ȸ   .
	unless(-e "$mem_dir/stipulation.txt") {
		open(STP, "$main_dir/lang/$FORM{'lang'}/stipulation.txt");
		open(MSTP, ">$mem_dir/stipulation.txt");
		foreach (<STP>) {
			print MSTP $_;
		}
		close(MSTP);
		close(STP);
	}
	# ̵ 丮 
	mkdir("$data_dir",0777);

	# id 丮 б  HTML  ... *^^*
	foreach ("default", "index") {
		open(HTML, ">$data_dir/$_.htm");
		print HTML "<script>\n";
		print HTML "window.alert('Access Reject!!! *^^*')\n";
		print HTML "history.go(-1)\n";
		print HTML "</script>";
		close(HTML);
	}

	#۰ ȯ 
	my $super_pwd = crypt($FORM{'admin_pwd01'} , "sp");
	open(AC, ">$data_dir/admin_conf.cgi");
	print AC "lang = $FORM{'lang'}\n";
	print AC "font_face = $FORM{'font_face'}\n";
	print AC "super_pwd = $super_pwd\n";
	close(AC);

	#  ȯ 
	unless(-e "$data_dir/common_conf.cgi") {
		open(CM, ">$data_dir/common_conf.cgi");
		print CM "img_url = $FORM{'img_url'}\n";
		print CM "use_mailer = on\n";
		print CM "mailer = sendmail\n";
		print CM "sendmail = /usr/lib/sendmail\n";
		print CM "smtp = mail.kornet.net\n";
		close(CM);
	}

	# ⺻ ȯ漳
	unless(-e "$data_dir/default_conf.cgi") {
		open(DC, ">$data_dir/default_conf.cgi");
		print DC "admin_email = $FORM{'admin_email'}\n";
		print DC "admin_name = $FORM{'admin_name'}\n";
		print DC "admin_url = $FORM{'admin_url'}\n";
		print DC "align = center\n";
		print DC "bgcolor = #FFFFFF\n";
		print DC "cate_list = side\n";
		print DC "cate_color = #090909\n";
		print DC "category = CGI,JAVA,HTML\n";
		print DC "cgi_skin = board_default\n";
		print DC "chk_view = on\n";
		print DC "date_color = #4272D7\n";
		print DC "date_order = <!--YEAR-->.<!--MON-->.<!--DAY-->\n";
		print DC "date_view = on\n";
		print DC "dongury = on\n";
		print DC "down_color = #090909\n";
		print DC "end_col = #D9E3F4\n";
		print DC "file_upload = on\n";
		print DC "file_view = on\n";
		print DC "font_color = #090909\n";
		print DC "font_face = $font_face\n";
		print DC "font_size = 9pt\n";
		print DC "head_color = #efefef\n";
		print DC "head_img = soya_st_white\n";
		print DC "hfont_color = #666666\n";
		print DC "home_view = on\n";
		print DC "html_opt = text_only\n";
		print DC "html_skin = board_default\n";
		print DC "img_skin = board_default\n";
		print DC "ip_view = on\n";
		print DC "lang = $FORM{'lang'}\n";
		print DC "leftmargin = 10\n";
		print DC "link_color = #4F4F96\n";
		print DC "list_num = 10\n";
		print DC "list_order = <!--CHK--><!--NUM--><!--TYPE--><!--SUBJECT--><!--NAME--><!--DATE--><!--CATE--><!--READ--><!--DOWN--><!--VOTE-->\n";
		print DC "page_move_num = 10\n";
		print DC "list_view = on\n";
		print DC "lock_use = on\n";
		print DC "max_data = 100000\n";
		print DC "max_etc = 800\n";
		print DC "max_file_size = 4.5\n";
		print DC "max_screen_size = 1.5\n";
		print DC "name_length = 10\n";
		print DC "name_view = on\n";
		print DC "notice_color = #efefef\n";
		print DC "num_color = #090909\n";
		print DC "num_view = on\n";
		print DC "over_color = #efefef\n";
		print DC "page_move_num = 10\n";
		print DC "read_color = #090909\n";
		print DC "read_view = on\n";
		print DC "screen_shot = on\n";
		print DC "search_interval = 500\n";
		print DC "search_view = on\n";
		print DC "select_color = #E5F8FF\n";
		print DC "send_writer = on\n";
		print DC "simple_height = 500\n";
		print DC "simple_width = 620\n";
		print DC "special_char = on\n";
		print DC "sort_opt = on\n";
		print DC "start_col = #FFFFFF\n";
		print DC "sub_length = 47\n";
		print DC "topmargin = 10\n";
		print DC "tpl_skin = board_default\n";
		print DC "tr_color01 = #ffffff\n";
		print DC "tr_color02 = #F6F6F6\n";
		print DC "use_etc = on\n";
		print DC "vote_color = #090909\n";
		print DC "width = 600\n";
		close(DC);
	}

	# ⺻ Ʈ  - ȸ 
	unless(-e "$data_dir/default_point.cgi") {
		open(DP, ">$data_dir/default_point.cgi");
		print DP "view = 1\n";
		print DP "vote = 1\n";
		print DP "write = 3\n";
		print DP "reply = 5\n";
		print DP "etc = 2\n";
		print DP "limit = 0\n";
		close(DP);
	}

	# ̹Ų  ̹  ؼ ϱ.
	unless(-e "$data_dir/img_size.cgi"){
		require "./cgi_lib/chk_img_size.cgi";
		&chk_img_size("$CONF{'img_skin'}", "$CONF{'head_img'}");
	}

	#Խ  ¾Ǿ Ȯ... ^^
	unless(-e "$data_dir/admin_conf.cgi"){
		$CONF{'lang'} = $FORM{'lang'};
		require "./cgi_lib/java_err.cgi";
		&java_err("fail_setup");
	}

	&head;

	print <<"    __SUCCESS__";
		<META HTTP-EQUIV=Refresh CONTENT=3;URL=$cgi_url>
		<br><br>
		<table border=0 align=center cellpadding=3 cellspacing=0>
			<tr>
				<td><img src=$main_url/img/img_skin/board_default/info.gif width=32 height=64></td>
				<td><img src=$main_url/img/img_skin/board_default/zero.gif width=12 height=64></td>
				<td class=cont>$SETUP{'success_msg'}</td>
			</tr>
		</table>

    __SUCCESS__

	&foot;

	#unlink ("./setup.cgi"); # ӹϼ ~ !!!!
}

sub head {
	print "Content-type: text/html\n\n";
	print <<"    __HEAD__";
		<html>
		<head><title>$title</title></head>
		<meta http-equiv=Content-Type content=text/html; charset="$charset">
		<style type='text/css'>
		<!--
		A:link {color:#56789A;font-size:9pt;text-decoration:none;}
		A:visited {color:#56789A;font-size:9pt;text-decoration:none;}
		A:active {color:#CC2160;font-size:9pt;text-decoration:underline;}
		A:hover {color:#CC2160;font-size:9pt;text-decoration:underline;}
		p,br,body,select,input,td,form,textarea,option,div {color:#000000;font-size:9pt;font-family:$font_face;}
		.cont{line-height:140%}
		.input {color:black; background-color:#ffffff; padding-top:3; border-width:1; border-color:#668FC2; border-style:solid; font-size:9pt;}
		.submit {font-size:9pt; font-family:$font_face; border-style:ridge; background-color:#f3f3f3; border-width:1pt; border-top-color:#ffffff; border-right-color:#eeeeee; border-bottom-color:#eeeeee; border-left-color:#ffffff;}-->
		</style>
		<body bgcolor="#FFFFFF" background="$main_url/img/setup_back.gif">
		<div align=center>
		<table border=0 width="100%" height="100%"><tr><td align=center valign=middle>
		<img src=$main_url/img/setup_logo.gif><br><br>
    __HEAD__
}

sub foot {
	print "<br><br><br><br><br><br></td></tr></table>\n";
	print "</div>\n";
	print "</body>\n";
	print "</html>\n";
}

exit;